<?php

namespace itguild\forms\table;

use itguild\forms\traits\CreateParams;
use itguild\forms\widgets\BaseWidget;

class ViewJsonTable
{
    use CreateParams;

    private array $data;

    private string $html = "";
    private string $json;

    private \Closure|false $beforePrintCell;

    private array $dataJson;
    public function __construct($json)
    {
        $this->json = $json;
        $this->data = json_decode($this->json, true);
        $this->dataJson = json_decode($this->data['data']['data'], true);


    }

    public function beginTable(): void
    {

        $paramsStr = $this->createParams($this->data['meta']['params']);
        $this->html = "<table $paramsStr>";
    }
    public function createColum()
    {
        foreach ($this->data['meta']['columns'] as $key => $column){
            if ($this->issetColumn($key)){
                if ($this->beforePrintCell){
                    $hook = $this->beforePrintCell;
                    $this->dataJson[$key] = $hook($key, $this->dataJson[$key]);
                }

                $this->html .= "<tr><th>" . $column . ": </th><td>" . $this->dataJson[$key] . "</td></tr>";

            }
        }


        return $this->html;
    }

    private function issetColumn($column)
    {

        if (isset($this->data['meta']['columns'])){
            foreach ($this->data['meta']['columns'] as $key => $currentColumn){
                if ($key === $column){
                    return true;
                }
            }
        }

        return false;
    }

    public function endTable()
    {
        $this->html .= "</table";
    }

    public function create()
    {
        $this->beginTable();
        $this->createColum();
        $this->endTable();
    }

    public function render()
    {

        echo $this->html;

    }

    public function setBeforePrintCell(\Closure $closure): void
    {
        $this->beforePrintCell = $closure;
    }
}